#include<unistd.h>
#include<sys/time.h>
#include<iostream.h>
#include<strstream.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>
#include"etext.h"
#include"sbst.h"
#include<mico/CosNaming.h>
#include"transactionval_impl.h"
#include"buchtrans_util.h"


void zeitexpand(char *erg,char *muster,int argc,char **argv)
{
  struct timeval tv;
  long datsec;
  struct tm *lt;
  char *p,*pz;
  gettimeofday(&tv,NULL);
  
  datsec = tv.tv_sec;
  lt=localtime(&datsec);
  pz=erg;
  p=muster;
  while(*p!='\0')
  {
    switch(*p)
    {
    case '%':
      {
	  switch(*(++p))
	  {
	  case '%':*pz++=*p++;
	      break;
	  case 'm':
	  {
	      sprintf(pz,"%d",lt->tm_mon+1);
	      pz+=strlen(pz);
	      p++;
	  }
	  break;
	  case 'q':
	  {
	      sprintf(pz,"%d",(lt->tm_mon+1)/4+1);
	      pz+=strlen(pz);
	      p++;
	  }
	  break;
	  case 'j':
	  {
	      sprintf(pz,"%d",lt->tm_year);
	      pz+=strlen(pz);
	      p++;
	  }
	  break;
	  default:
	      cerr << "Unbekannt " << *p << endl;
	      p++;
	  }
      }
      break;
    case '$':
      {
	  int argnr = strtol(p+1,&p,10);
	  if(argnr < 1 || argnr >= argc)
	  {
	      cerr << "Ungltige Variable $" << argnr << endl;
	      exit(1);
	  }
	  argnr--;
	  for(const char *ap=argv[argnr];*ap!='\0';*pz++=*ap++);
      }
    default:  
      {
	  *pz++=*p++;
      }
    }
  }
  *pz='\0';
}

const char *tname="Buchhaltung";

main(int argc,char **argv)
{
  FILE *fp = NULL;
  char *ret = NULL;
  int h,s;
  char *p;
  char *konto;
  char *betragstr;
  char puffer[256];
  char ergpuffer[256];
  char text[1024];
  buch::Halbsatz hs[10];
  buch::Betrag soll;
  buch::Betrag haben;
  
  CORBA::ORB_var orb = CORBA::ORB_init (argc, argv, "mico-local-orb");

  /* Fabriken fr Values einrichten */
  transaction_factory * transfac = new transaction_factory;
  orb->register_value_factory("IDL:buch/transaction:1.0", transfac);

  faelligkeit_factory * faelligfac = new faelligkeit_factory;
  orb->register_value_factory("IDL:buch/faelligkeit:1.0", faelligfac);

  argc--;argv++; // bergehe Programmname;
  
  /*----------- Buchhaltung ermitteln ------------*/
  if((p=getenv("EVB_BUCH"))!=NULL)
  {
      tname=p;
  }
  if(argc>0 && strcmp(argv[0],"-db")==0)
  {
      if(argv[1]==NULL)
      {
         cerr << "-db Buchhaltungsdb" << endl;
	 exit(1);
      }
      tname=argv[1];
      argc-=2;argv+=2;
  }
  if(argc>0)
  {
      fp = fopen(argv[0],"r");
      if(fp == NULL) cerr << "Buchung " << argv[0] << " nicht gefunden !\n";
      argc--; argv++; // bergehe Buchungsdatei
  }
  if(fp==NULL) fp = stdin;
  
  buch::date *faelligam=NULL;

  Sbst btsam(text,1024);  
  while((ret = fgets(puffer,256,fp))!=NULL &&  strncmp(puffer,"S:",2)!=0 && strncmp(puffer,"H:",2)!=0)
  {
      if(puffer[0]=='#') continue;
      zeitexpand(ergpuffer,puffer,argc,argv);
      if(strncmp(ergpuffer,"faellig",7)==0)
      {
	  for(p=ergpuffer+7;*p!='\0' && !isdigit(*p);p++);
	  faelligam = new buch::date;
	  if(sscanf(p,"%u.%u.%u",&(faelligam->tag),&(faelligam->monat),&(faelligam->jahr))!=3 || faelligam->tag > 31 || faelligam->monat > 12)
	  {
	      cerr << "Ungltiges Datum " << p << endl;
	      exit(1);
	  }
      }
      else
      {
	  
	  // cout << ergpuffer;
	  btsam.dazu(trim(ergpuffer));btsam.dazu(" ");
      }
  }
 
 
  int i=0;
  int st = -1;  // Position des *
  while(ret != NULL && ((s=(strncmp(puffer,"S:",2)==0))
                     || (h=(strncmp(puffer,"H:",2)==0))))
  {
    p=puffer+2;while(isspace(*p)) p++;
    konto = p;
    leseKontonr(hs[i].konto,konto,&p);

    
    betragstr = trim(p);
    if(betragstr[0]=='*')
    {
	if(st!=-1)
	{
	    cerr << "Nur ein * erlaubt " << endl;
	    exit(-1);
	}
	st = i;
	hs[i].betrag=(long)0;
	hs[i].sh = ( s ? buch::Soll : buch::Haben);
    }
    else 
    {
	if(betragstr[0]=='$')
	{
	    int argnr=atoi(betragstr+1)-1;
	    if(argnr >= argc)
	    {
		cerr << "Ungltige Argumentnummer " << argnr+1 << endl;
		exit(1);
	    }
	    betragstr=argv[argnr];
	}
	istrstream istr(betragstr);
	istr >> hs[i].betrag;
	if(s)
	{
	    hs[i].sh = buch::Soll;
	    soll += hs[i].betrag;
	}
	else
	{
	    hs[i].sh = buch::Haben;
	    haben += hs[i].betrag;
	}
    }
    i++;
    ret = fgets(puffer,1024,fp);   
  }
  if(st != -1)
  {
      if(hs[st].sh == buch::Soll)
      {
	  hs[st].betrag = haben - soll;
	  soll += hs[st].betrag;
      }
      else
      {
	  hs[st].betrag = soll - haben;
	  haben += hs[st].betrag;
      }
  }
  if(!(soll == haben))
  {
      cerr << "Soll-Haben-Ungleichheit:\n soll = "
	   << soll << " haben = " << haben << endl;
      cerr << "--> Erwarte Ausnahme ... " << endl;
  }
  int hslen=i;

  buch::Halbsatz_seq_var hsseq = new buch::Halbsatz_seq(hslen,hslen,hs);
#if 0
  /* leider lieferte die Verwendung (*hsseq)[i] statt hs[i] 
     sehr merkwrdige Ergebnisse ... */
  for(i=0;i<hslen;i++)
  {
      cout << hs[i] << endl;
  }
  cout << "Sequenz:\n";
  for(i=0;i<hsseq->length();i++)
  {
      cout << (*hsseq)[i] << endl;
  }
#endif

  buch::transaction_var btrans;
  if(faelligam==NULL)
  {
      btrans = transfac->create(0,text,*hsseq);
  }
  else
  {
      cerr << "Fllig am " << *faelligam << endl;
      btrans = faelligfac->create(0,text,*hsseq,*faelligam);
  }

  cout << btrans->text() << endl;
  for(i=0;i< btrans->hs().length();i++)
  {
      cout << "\t\t" << btrans->hs()[i] << endl;
  }

  /*------- Ermittle Buchhaltungstransaktionsverwaltung -----*/
  /* ------------ Nameserver ermitteln ------------*/
  CORBA::Object_var nsobj = orb->resolve_initial_references("NameService");
  if(CORBA::is_nil(nsobj))
  {
      cerr << "Hallo: Initial Service NameService not resolved " << endl;
      exit(1);
  }
  CosNaming::NamingContext_var nc =CosNaming::NamingContext::_narrow(nsobj);
  CORBA::Object_var transver_obj;
  CosNaming::Name name;
  name.length (2);
  name[0].id   = CORBA::string_dup(tname);
  name[0].kind = CORBA::string_dup("");
  name[1].id   = CORBA::string_dup("transaktionen");
  name[1].kind = CORBA::string_dup("");
  try
  {
      transver_obj = nc->resolve(name);
  }
  catch(CosNaming::NamingContext::NotFound_catch& ex)
  {
      cerr << "Name Buchhaltung/transaktionen nicht gefunden:"
	   << ex.why << endl;
      exit(1);
      
  }
  catch(CosNaming::NamingContext::InvalidName_catch ex)
  {
      cerr << "Invalid name " << endl;
      exit(1);
  }
  catch(CosNaming::NamingContext::CannotProceed_catch nex)
  {
      cerr << "Bitte anderen Nameserver Fragen .... " << endl;
  }
  catch(CORBA::SystemException_catch ex)
  {
      cerr << "Beim fragen des Nameservers: ";
      ex._print(cerr);
      exit(1);
  }
  if(transver_obj->_non_existent())
  {
      cerr << "Objekt sagt, es sei gar nicht existent " << endl;
      exit(1);
  }

  buch::haltung_var transver = buch::haltung::_narrow(transver_obj);
  if(CORBA::is_nil(transver))
  {
      cerr << "Objekt ist ein " << transver->_ior()->objid()
	   << " und kein IDL:buch/haltung:1.0" << endl;
  }
  
  buch::Tid erg;
  try
  {
      erg=transver->buche(btrans.in());
  }
  catch(buch::notexistent_catch &ex)
  {
      cerr << "Konto " << ex.diese << " existiert nicht " << endl;
      exit(1);
  }
  catch(buch::sollungleichhaben_catch &ex)
  {
      cerr << "Summe Soll ist ungleich Summe Haben " << endl;
      exit(1);
  }
  catch(buch::databaseerr_catch &ex)
  {
      cerr << "Datenbankfehler :" << ex.what << endl;
      exit(1);
  }
  catch(CORBA::SystemException_catch& ex)
  {
      cerr << "Beim Absetzen der Buchung: ";
      ex._print(cerr);
      exit(1);
  }

  cerr << "Transaktion mit ID " << erg << " verewigt " << endl;
}




