#include<stdlib.h>
#include<strstream.h>
#include<rpglib.h>
#include"buchtrans_impl.h"
#include"buchtrans_util.h"
extern PgConnection *pgdb;

int buchtrans_debuglevel=0;

buch::Tid lasttid()
{
    buch::Tid ret;
    PGresult* res = pgdb->ExecRetTuples("SELECT lasttid();");
    ret = strtol(PQgetvalue(res,0,0),NULL,10);
    PQclear(res);

    return ret;
}
// Implementation for interface haltung

buch::Tid
haltung_impl::buche( buch::transaction* t )
  throw(
    ::CORBA::SystemException,
    ::buch::notexistent,	
    ::buch::sollungleichhaben,	
    ::buch::databaseerr)

{
  buch::Tid neuetid=0;
  buch::faelligkeit *f;
  int i;
  buch::Betrag ssoll=(long)0;
  buch::Betrag shaben=(long)0;

  if(buchtrans_debuglevel > 0)
  { cout << t->tid() << " " << t->text() << endl;
  }
  try
  {
      PgTransaction trans(*pgdb);
      f=buch::faelligkeit::_downcast(t);
      if(f)
      {
	  if(buchtrans_debuglevel > 0)
	  {
	      cout << "fllig am " << f->faellig() << endl;
	  }
	  trans.ExecCommand("INSERT INTO bfaellig(btext,faellig,bdatum,aendtaeter) VALUES ('%s','%d-%d-%d',now(),'%s')",
			(const char *)(f->text()),
			f->faellig().jahr,f->faellig().monat,f->faellig().tag,
			"buch");
      }
      else
      {
	  trans.ExecCommand("INSERT INTO btrans (btext,bdatum,aendtaeter) "
			    "VALUES ('%s',now(),'%s')",
			    (const char *)(t->text()),"buch");
      }

      neuetid = lasttid();
      for(i=0;i< t->hs().length();i++)
      {
	  char betragstr[32];
	  ostrstream ostr(betragstr,32);
	  char sh;
	  ostr << t->hs()[i].betrag;
	  betragstr[ostr.pcount()]='\0';  // !#@ grmpf
	  PgResultHandle res = trans.ExecRetTuples("SELECT sumsoll,sumhaben FROM konto WHERE firnr=%d AND knr='%s' FOR UPDATE",t->hs()[i].konto.firnr,(const char *)(t->hs()[i].konto.name));
	  if(PQntuples(res.ptr())!=1)
	  {
	      mico_throw(buch::notexistent(t->hs()[i].konto));
	  }
	  
	  if(t->hs()[i].sh == buch::Soll)
	  {
	      sh='S';
	      ssoll += t->hs()[i].betrag;
	      trans.ExecCommand("UPDATE konto SET sumsoll=sumsoll+'%s' WHERE firnr=%d AND knr='%s' ",(char *)betragstr,t->hs()[i].konto.firnr,(const char *)(t->hs()[i].konto.name));
	  }
	  else
	  {
	      sh='H';
	      shaben += t->hs()[i].betrag;
	      trans.ExecCommand("UPDATE konto SET sumhaben=sumhaben+'%s' WHERE firnr=%d AND knr='%s' ",(char *)betragstr,t->hs()[i].konto.firnr,(const char *)(t->hs()[i].konto.name));
	  }
          trans.ExecCommand("INSERT INTO btranshs (tid,firnr,knr,sh,betrag) "
			"VALUES (%d,%d,'%s','%c',%s)",
			neuetid,
			t->hs()[i].konto.firnr,
			(const char *)(t->hs()[i].konto.name),
			sh,
                        (char *)betragstr);
	  if(buchtrans_debuglevel > 0)
	  {
	      cout << "\t\t" << t->hs()[i] << endl;
	  }
      }
      if((ssoll == shaben))
      {
	  trans.commit();
      }
      else
      {
	  mico_throw(buch::sollungleichhaben());
      }
  }
  catch(PgException &pex)
  {
      mico_throw(buch::databaseerr(pex.what()));
  }
  return neuetid; 
}




