
#include<rpglib.h>
#include<stdio.h>
#include"buchtrans_util.h"
#include"konto_impl.h"

#include<iostream.h>
#include<strstream.h>

extern CORBA::ORB_ptr orb;
extern PgConnection *pgdb;
// Implementation for interface Konto

buch::Kontonr*
Konto_impl::get_knr()
  throw(
    ::CORBA::SystemException)

{
  buch::Kontonr* retval;
  int r;
  char knrstr[64];

  CORBA::Object_var curobj = orb->resolve_initial_references("POACurrent");
  PortableServer::Current_var cur = PortableServer::Current::_narrow(curobj);
  assert(!CORBA::is_nil(cur));
  PortableServer::ObjectId_var oid = cur->get_object_id();
  CORBA::String_var idstr = PortableServer::ObjectId_to_string(oid);
  // cout << "get_knr: " << idstr << " ";

  retval = new buch::Kontonr;
  r=leseKontonr(*retval,idstr,NULL);
  assert(r);

  //cout << *retval << endl;
  
  return retval; 
}


char*
Konto_impl::get_beschreibung()
  throw(
    ::CORBA::SystemException,
    ::buch::databaseerr)
{
  char* retval;
  PgResultHandle res;
  buch::Kontonr kontonr;
  int r;

  CORBA::Object_var curobj = orb->resolve_initial_references("POACurrent");
  PortableServer::Current_var cur = PortableServer::Current::_narrow(curobj);
  assert(!CORBA::is_nil(cur));
  PortableServer::ObjectId_var oid = cur->get_object_id();
  CORBA::String_var idstr = PortableServer::ObjectId_to_string(oid);
  // cout << idstr << endl;
  r=leseKontonr(kontonr,idstr,NULL);
  assert(r);
  try
  {
    res = pgdb->ExecRetTuples("SELECT bezeichnung FROM konto WHERE firnr=%d AND knr='%s'",kontonr.firnr,(const char *)kontonr.name);
 
  }
  catch(PgException& ex)
  {
    cerr << "Ausnahme: " << ex.what() << endl;
    mico_throw(buch::databaseerr(ex.what()));
  }
  if(PQntuples(res.ptr())!=1)
  {
    cerr << "Konto " << kontonr << " existiert nicht!" << endl;
    mico_throw(CORBA::OBJECT_NOT_EXIST());
  }
  retval = CORBA::string_dup(PQgetvalue(res.ptr(),0,0));
  return retval; 
}


buch::Betrag
Konto_impl::get_saldo()
  throw(
    ::CORBA::SystemException,
    ::buch::databaseerr)

{
  buch::Betrag saldo;
  buch::Betrag anfang;
  buch::Betrag sumsoll;
  buch::Betrag sumhaben;
  PgResultHandle res;
  buch::Kontonr kontonr;
  int r;

  CORBA::Object_var curobj = orb->resolve_initial_references("POACurrent");
  PortableServer::Current_var cur = PortableServer::Current::_narrow(curobj);
  assert(!CORBA::is_nil(cur));
  PortableServer::ObjectId_var oid = cur->get_object_id();
  CORBA::String_var idstr = PortableServer::ObjectId_to_string(oid);
  // cout << idstr << endl;
  r=leseKontonr(kontonr,idstr,NULL);
  assert(r);
  try
  {
    res = pgdb->ExecRetTuples("SELECT anfang,sumsoll,sumhaben,art FROM konto WHERE firnr=%d AND knr='%s'",kontonr.firnr,(const char *)kontonr.name);
 
  }
  catch(PgException& ex)
  {
    cerr << "Ausnahme: " << ex.what() << endl;
    mico_throw(buch::databaseerr(ex.what()));
  }
  if(PQntuples(res.ptr())!=1)
  {
    cerr << "Konto " << kontonr << " existiert nicht!" << endl;
    mico_throw(CORBA::OBJECT_NOT_EXIST());
  }
  istrstream istr1(PQgetvalue(res.ptr(),0,0));
  istrstream istr2(PQgetvalue(res.ptr(),0,1));
  istrstream istr3(PQgetvalue(res.ptr(),0,2));
  istr1 >> anfang;
  istr2 >> sumsoll;
  istr3 >> sumhaben;

  // cout << "Kontotyp=" << PQgetvalue(res.ptr(),0,3)[0] << endl;
  switch(PQgetvalue(res.ptr(),0,3)[0])
  {
  case 'A': // Aktivkonto
    saldo = anfang+sumsoll-sumhaben;
    break;
  case 'P': // Passivkonto
    saldo = anfang+sumsoll-sumhaben;
    break;
  case 'W': // Aufwandskonto
    saldo = sumsoll-sumhaben;
    break;
  case 'E': // Ertragskonto
    saldo = sumhaben-sumsoll;
    break;
  default:
    saldo=(long)0;
    assert(0);
  }
  return saldo; 
}


buch::Konto_typ
Konto_impl::get_ktyp()
  throw(
    ::CORBA::SystemException,
    ::buch::databaseerr)
{
  PgResultHandle res;
  buch::Kontonr kontonr;
  int r;

  CORBA::Object_var curobj = orb->resolve_initial_references("POACurrent");
  PortableServer::Current_var cur = PortableServer::Current::_narrow(curobj);
  assert(!CORBA::is_nil(cur));
  PortableServer::ObjectId_var oid = cur->get_object_id();
  CORBA::String_var idstr = PortableServer::ObjectId_to_string(oid);
  // cout << idstr << endl;
  r=leseKontonr(kontonr,idstr,NULL);
  assert(r);
  try
  {
    res = pgdb->ExecRetTuples("SELECT art FROM konto WHERE firnr=%d AND knr='%s'",kontonr.firnr,(const char *)kontonr.name);
 
  }
  catch(PgException& ex)
  {
    cerr << "Ausnahme: " << ex.what() << endl;
    mico_throw(buch::databaseerr(ex.what()));
  }
  if(PQntuples(res.ptr())!=1)
  {
    cerr << "Konto " << kontonr << " existiert nicht!" << endl;
    mico_throw(CORBA::OBJECT_NOT_EXIST());
  }
  switch(PQgetvalue(res.ptr(),0,0)[0])
  {
  case 'A': return buch::aktiv;
  case 'P': return buch::passiv;
  case 'W': return buch::aufwand;
  case 'E': return buch::ertrag;
  default:
    assert(0);
    return buch::aktiv;
  }
}








