#include<iostream.h>
#include<fstream.h>
#include<signal.h>
#include<string.h>
#include<unistd.h>
#include<rpglib.h>
#include"corbalogger.h"
#include"control_impl.h"
#include"konto_impl.h"
#include"kontonamingkontext_impl.h"
//#include<mico/CosNaming.h>
int main_debuglevel=0;

#define RUNPATH "./"

extern int kontonaming_debuglevel;
Debugvar dvmt[]=
{
   {"main",&main_debuglevel},
   {"kontonaming",&kontonaming_debuglevel},
   {NULL,NULL}
};
CorbaLog corbalog;

PgConnection *pgdb=NULL;
static const char *tname="buchhaltung";
static KontoNamingContext_impl *ncservant; // Unser KontoNamingContext
CORBA::ORB_ptr orb;
void sighandler (int sig)
{
  if (!CORBA::is_nil (orb)) {
    orb->shutdown (TRUE);
  }
  if(pgdb)
  {
      delete pgdb;
  }
}

/*------------------- Control-Interface ----------------------------*/
class BuchControl_impl: public Control_impl
{
public:
    BuchControl_impl::BuchControl_impl(const char *pname,Debugvarmap _dvm,int dvmsz):Control_impl(pname,_dvm,dvmsz) {}
  void exportnames( CosNaming::NamingContext_ptr nc) 
      throw(::CORBA::SystemException);
};

void BuchControl_impl::exportnames( CosNaming::NamingContext_ptr nc) 
      throw(::CORBA::SystemException)
{
  /*---- Verffentliche unsere Interfaces im Nameserver ----*/  
  CosNaming::Name contextname;
  contextname.length (1);
  contextname[0].id = CORBA::string_dup (tname);
  contextname[0].kind = CORBA::string_dup ("");
  CORBA::Object_var mnc_obj;
  CosNaming::NamingContext_var mnc;
    
  corbalog << "Verffentliche unsere Interfaces im Nameserver ... " << endl;
  try
  {
      mnc_obj = nc->bind_new_context(contextname);
      if(CORBA::is_nil(mnc_obj))
      {
	  corbalog.log(Syslog::Err,"Dialupmanager-Kontext ist NIL");
	  return;
      }
      mnc=CosNaming::NamingContext::_narrow(mnc_obj);
  }
  catch(CosNaming::NamingContext::AlreadyBound_catch &nex)
  {
      corbalog << "Hoppla: Schon gebunden !" << endl;
      mnc_obj = nc->resolve(contextname);
      mnc=CosNaming::NamingContext::_narrow(mnc_obj);
  }
  catch(CosNaming::NamingContext::NotFound_catch &nex)
  {
      corbalog.setprio(Syslog::Err);
      corbalog << nex << ": da " << nex.why << endl;
      corbalog.setprio(Syslog::Debug);
      return;
  }
  catch (CosNaming::NamingContext::CannotProceed_catch &exc)
  {
      corbalog.log(Syslog::Err,"CannotProceed exception");
      return;
  }
  catch (CosNaming::NamingContext::InvalidName_catch &exc)
  {
      corbalog.log(Syslog::Err,"InvalidName exception");
      return;
  }

  /*----- Kontoserver einbinden --------*/
  CosNaming::Name name;
  name.length (1);
  name[0].id = CORBA::string_dup ("kontos");
  name[0].kind = CORBA::string_dup ("");
  corbalog << "binde konto-namecontext ... " << endl;

  try
  {
      mnc->bind_context(name,ncservant->_this());
  }
  catch(CosNaming::NamingContext::AlreadyBound_catch &nex)
  {
      corbalog << "Hoppla: Schon gebunden !\n"
	   << "Weg da, jetzt komme ich ... " << endl;
      mnc->rebind_context(name,ncservant->_this());
  }
  catch(CosNaming::NamingContext::NotFound_catch &nex)
  {
      corbalog << nex << ": da " << nex.why << endl;
  }
  catch (CosNaming::NamingContext::CannotProceed_catch &exc)
  {
    corbalog << "CannotProceed exception" << endl;
  }
  catch (CosNaming::NamingContext::InvalidName_catch &exc)
  {
    corbalog << "InvalidName exception" << endl;
  }
}

void usage(char *progname)
{
    cerr << "Aufruf: " << progname
	 << "[mico-args ...] "
	 << "-db postgresdatabase"
	 << endl;
    exit(1);
}

#if 0
void printref(PortableServer::POA_ptr kontopoa,char *konto)
{
  PortableServer::ObjectId_var kid = PortableServer::string_to_ObjectId(konto);
  CORBA::Object_var kref=kontopoa->create_reference_with_id(kid,"IDL:buch/Konto:1.0");
  CORBA::String_var krefstr= orb->object_to_string(kref);
  cout << "Beispiel fuer Referenz  " << konto << "\n" << krefstr << endl;
}
#endif

int main(int argc,char **argv)
{
  char conninfo[128];conninfo[0]='\0';
  char *cip=conninfo;
  int cirest=128;
  orb = CORBA::ORB::_nil ();
  signal (SIGINT, sighandler);
  signal (SIGTERM, sighandler);
  char *prog = rindex(argv[0],'/');
  prog = (prog ? prog+1 : argv[0]);
  // POA-Name faelschen
  const char *implname = NULL;
  char *dbname="";
  char implnamebuf[64];
  char **orbargv = new char*[argc+2+1];
  int orbargc=0;

  for(int i=0;i<argc;i++)
  {
    if(strcmp(argv[i],"-POAImplName")==0 && i+1<argc)
    {
	implname = argv[i+1];
    }
    if(strcmp(argv[i],"-db")== 0)
    {
	if(i+1>=argc) usage(argv[0]);
	i++;
	dbname=argv[i];
	tname=argv[i];
	snprintf(cip,cirest,"dbname=%s",argv[i]);
	int l = strlen(cip);
	cirest-=l;
	cip+=l;
    }
    else // das muss ein Orb-argument sein ...
    {
	orbargv[orbargc++]=argv[i];
    }
  }
  if(implname==NULL)
  {
    snprintf(implnamebuf,64,"Kontopoa%s",dbname);
    orbargv[orbargc++]="-POAImplName";
    orbargv[orbargc++]=implnamebuf;
  }
  orbargv[orbargc]=NULL;

  // Datenbank oeffnen
  cerr << "Oeffne Postgresdatenbank mit " << conninfo << endl;
  try
  {
      pgdb=new PgConnection(conninfo);
  }
  catch(PgException &ex)
  {
      cerr << "Kann Datenbank nicht oeffnen: " << ex.what() << endl;
      exit(1);
  }

  // Orb und POA initialisieren
  orb = CORBA::ORB_init(orbargc,orbargv,"mico-local-orb");
  CORBA::Object_var poaobj = orb->resolve_initial_references("RootPOA");
  PortableServer::POA_var rootpoa = PortableServer::POA::_narrow(poaobj);
  PortableServer::POAManager_var rootpoamgr = rootpoa->the_POAManager();
  PortableServer::POA_var kontopoa;

  try
  {
      CORBA::PolicyList pl;
      pl.length(10);
      int p=0;
      pl[p++] = rootpoa->create_servant_retention_policy(PortableServer::NON_RETAIN);
      pl[p++] = rootpoa->create_request_processing_policy(PortableServer::USE_DEFAULT_SERVANT);
      pl[p++] = rootpoa->create_id_uniqueness_policy(PortableServer::MULTIPLE_ID);
      pl[p++] = rootpoa->create_id_assignment_policy(PortableServer::USER_ID);
      //pl[p++] = rootpoa->create_implicit_activation_policy(PortableServer::IMPLICIT_ACTIVATION);
      pl[p++] = rootpoa->create_lifespan_policy(PortableServer::PERSISTENT);
      pl.length(p);
      
      kontopoa = rootpoa->create_POA("Kontopoa",rootpoamgr,pl);
  }
  catch(PortableServer::POA::InvalidPolicy_catch &ex)
  {
      cerr << "InvalidPolicy: ";
      ex->_print(cerr);
      cerr << " Index " << ex->index << endl;
      exit(1);
  }
  catch (CORBA::SystemException_catch &ex)
  {
      cout << ex->minor() << endl;
  }

  // request_processing_policy USE_DEFAULT_SERVANT
  Konto_impl *kontoservant = new Konto_impl;
  kontopoa->set_servant(kontoservant);
  rootpoamgr->activate();

  if(main_debuglevel>2)
  {
  /* ist unser manager aktiv ? */
    PortableServer::POAManager_var kontopoamgr = kontopoa->the_POAManager();
    PortableServer::POAManager::State mgrstate = kontopoamgr->get_state();
    cout << "Kontopoa ist ";
    switch(mgrstate)
    {
    case PortableServer::POAManager::HOLDING:    cout <<  "HOLDING"; break; 
    case PortableServer::POAManager::ACTIVE:     cout <<  "ACTIVE"; break;
    case PortableServer::POAManager::DISCARDING: cout <<  "DISCARDING"; break; 
    case PortableServer::POAManager::INACTIVE:   cout <<  "INACTIVE"; break;
    }
    cout << endl;
  }
#if 0
  /* test */
  printref(kontopoa.in(),"99:Kasse");
  printref(kontopoa.in(),"99:essen");
  cout << "Nichtexistentes Konto:";
  printref(kontopoa.in(),"99:pdsbeitraege");
#endif
  // Baue unseren Namingcontext
  ncservant = new KontoNamingContext_impl(kontopoa,pgdb);
  PortableServer::ObjectId_var ncoid = rootpoa->activate_object(ncservant);

  rootpoamgr->activate();

  // Haenge unsern Nameservice in den root-Service ein
  CORBA::Object_var nsobj = orb->resolve_initial_references("NameService");
  if(CORBA::is_nil(nsobj))
  {
    cerr << "Initial Service NameService not resolved " << endl;
    exit(1);
  }
  CosNaming::NamingContext_var nc =CosNaming::NamingContext::_narrow (nsobj);

  cerr << "----- ffne Corba-log --------" << endl;
  CosEventChannelAdmin::EventChannel_var syslogev;
 
  try
  {
      CosNaming::Name syslogevname;
      CORBA::Object_var syslogevobj=nc->resolve(StringToName(syslogevname,"syslog"));
      syslogev = CosEventChannelAdmin::EventChannel::_narrow(syslogevobj);
      if(CORBA::is_nil (syslogev))
      {
	  // throw
	  cerr << "syslog hat falschen typ " << endl;
	  exit(1);
      }
  }
  catch(...)
  {
      cerr << "Kann syslog nicht finden !! " << endl;
      exit(1);
  }
      
  corbalog.init(orb,syslogev,"buchhaltung",prog);
  BuchControl_impl *controlservant = new BuchControl_impl(prog,dvmt,sizeof(dvmt)/sizeof(struct Debugvar));


  rootpoa->activate_object(controlservant);
  {
      char ctlpath[128];
      snprintf(ctlpath,128,"%s%s.ctlref",RUNPATH,prog);
      ofstream aus(ctlpath);
      assert(aus);
      aus << orb->object_to_string(controlservant->_this());
  }

  controlservant->exportnames(nc);

  orb->run();
}











