#include"corbalogger.h"
#include"kontonamingkontext_impl.h"

extern CorbaLog corbalog;
int kontonaming_debuglevel=0;
// Implementation for interface NamingContext

void
KontoNamingContext_impl::bind( const CosNaming::Name& n, CORBA::Object_ptr obj )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName,
    ::CosNaming::NamingContext::AlreadyBound)

{
  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

}


void
KontoNamingContext_impl::rebind( const CosNaming::Name& n, CORBA::Object_ptr obj )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName)

{
  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

}


void
KontoNamingContext_impl::bind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName,
    ::CosNaming::NamingContext::AlreadyBound)

{
  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

}


void
KontoNamingContext_impl::rebind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName)

{
  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

}


CORBA::Object_ptr
KontoNamingContext_impl::resolve( const CosNaming::Name& n )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName)

{
  CORBA::Object_ptr retval;
  PgResultHandle res;  
  int i;
  int firnr;
  char name[64];
  int r;

  if(n.length()>1)
  {
      CosNaming::NamingContext::NotFound exc;
      exc.why = CosNaming::NamingContext::missing_node;
      exc.rest_of_name = n;
      mico_throw (exc);
  }
  if(kontonaming_debuglevel > 1)
  {
      corbalog << "Resolving " << n[0].id << endl;
  }
  r=sscanf(n[0].id,"%d:%s",&firnr,name);
  
  if(r!=2) mico_throw(::CosNaming::NamingContext::InvalidName());
    
  try
  {
    res = pdb->ExecRetTuples("SELECT firnr,knr FROM konto WHERE firnr=%d AND knr='%s';",firnr,name);
  }
  catch(PgException& ex)
  {
    corbalog.setprio(Syslog::Err);
    corbalog << "Postgres: " << ex.what() << endl;
    corbalog.setprio(Syslog::Debug);
    mico_throw (CORBA::UNKNOWN());
  }
  if(PQntuples(res.ptr())>0)
  {
    PortableServer::ObjectId_var kid = PortableServer::string_to_ObjectId(n[0].id);
    retval = kontopoa->create_reference_with_id(kid,"IDL:buch/Konto:1.0");
  }
  else
  {
    mico_throw(CosNaming::NamingContext::NotFound(CosNaming::NamingContext::missing_node,n));
  }
  return retval; 
}


void
KontoNamingContext_impl::unbind( const CosNaming::Name& n )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName)

{
  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

}


CosNaming::NamingContext_ptr
KontoNamingContext_impl::new_context()
  throw(
    ::CORBA::SystemException)

{
  CosNaming::NamingContext_ptr retval;

  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

  return retval; 
}


CosNaming::NamingContext_ptr
KontoNamingContext_impl::bind_new_context( const CosNaming::Name& n )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::AlreadyBound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName)

{
  CosNaming::NamingContext_ptr retval;

  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

  return retval; 
}


void
KontoNamingContext_impl::destroy()
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotEmpty)

{
}


void
KontoNamingContext_impl::list( CORBA::ULong how_many, CosNaming::BindingList*& bl, CosNaming::BindingIterator_ptr& bi )
  throw(
    ::CORBA::SystemException)

{
  PGresult *res;  
  int anz,atupels;
  char namestring[64];
  bi = CosNaming::BindingIterator::_nil();
  try
  {
    res = pdb->ExecRetTuples("SELECT firnr,knr FROM konto");
  }
  catch(PgException& ex)
  {
    corbalog.setprio(Syslog::Err);
    corbalog << "Postgres: " << ex.what() << endl;
    corbalog.setprio(Syslog::Debug);
    mico_throw (CORBA::UNKNOWN());
  }
  atupels=PQntuples(res);
  
  anz = (atupels < how_many ? atupels : how_many);
  bl = new CosNaming::BindingList(anz);
  bl->length(anz);
  
  for(int t=0;t<anz;t++)
  {
    snprintf(namestring,64,"%s:%s",PQgetvalue(res,t,0),PQgetvalue(res,t,1));
    (*bl)[t].binding_name.length(1);
    (*bl)[t].binding_name[0].id=CORBA::string_dup(namestring);
    (*bl)[t].binding_name[0].kind=CORBA::string_dup("");
    (*bl)[t].binding_type = CosNaming::nobject;
  }
  if(how_many<atupels)
  {
      if(kontonaming_debuglevel > 1)
      {
	corbalog << "Liefere Bindingiterator ..." << endl;
      }
      KontoBindingIterator_impl *bii = new KontoBindingIterator_impl(res,anz);
      bi=bii->_this();
      bii->_remove_ref (); // ?? geklaut aus Mico-nsd
  }
  else
  {
      PQclear(res);
  }
}


// Implementation for interface BindingIterator

CORBA::Boolean
KontoBindingIterator_impl::next_one( CosNaming::Binding*& b )
  throw(
    ::CORBA::SystemException)

{
  CORBA::Boolean retval;
  char namestring[64];
  if(kontonaming_debuglevel > 1)
  {
    corbalog << "KontoBindingIterator::next_one .... " << endl;
  }

  if(akt<PQntuples(res))
  {
    snprintf(namestring,64,"%s:%s",PQgetvalue(res,akt,0),PQgetvalue(res,akt,1));
    if(kontonaming_debuglevel > 1)
    {
      corbalog << namestring << endl;
    }
    b = new CosNaming::Binding;
    b->binding_name.length(1);
    b->binding_name[0].id=CORBA::string_dup(namestring);
    b->binding_name[0].kind=CORBA::string_dup("");
    b->binding_type = CosNaming::nobject;
    akt++;
    retval=TRUE;
  }
  else
  {
    b = NULL;
    if(kontonaming_debuglevel > 1)
    {
      corbalog << "KontoBindingIterator::next_one : keines mehr da !" << endl;
    }
    retval=FALSE;
  }
  return retval; 
}


CORBA::Boolean
KontoBindingIterator_impl::next_n( CORBA::ULong how_many, CosNaming::BindingList*& bl )
  throw(
    ::CORBA::SystemException)

{
  CORBA::Boolean retval;

  char namestring[64];
  int atupels=PQntuples(res);
  int rest = atupels-akt;
  assert(rest>=0);
  int anz = (rest < how_many ? rest : how_many);
  
  if(kontonaming_debuglevel > 1)
  {
    corbalog << "next_n(" << how_many << ") noch " << rest << " da,[" 
	     << akt << ".." << atupels << "[ anz=" << anz << "Stueck" << endl;
  }
  bl = new CosNaming::BindingList(anz);
  bl->length(anz);
  for(int i=0;i<anz;i++)
  {
    snprintf(namestring,64,"%s:%s",PQgetvalue(res,akt+i,0),PQgetvalue(res,akt+i,1));
    (*bl)[i].binding_name.length(1);
    (*bl)[i].binding_name[0].id=CORBA::string_dup(namestring);
    (*bl)[i].binding_name[0].kind=CORBA::string_dup("");
    (*bl)[i].binding_type = CosNaming::nobject;
  }
  akt+=anz;
  return (CORBA::Boolean)(rest>0);
}


void
KontoBindingIterator_impl::destroy()
  throw(
    ::CORBA::SystemException)

{
  extern CORBA::ORB_ptr orb;
  if(kontonaming_debuglevel > 1)
  {
    corbalog << "Zerstoere KontoBindingIterator ... " << endl;
  }
  PQclear(res);
  CORBA::Object_var obj = orb->resolve_initial_references ("POACurrent");
  PortableServer::Current_var pc = PortableServer::Current::_narrow (obj);
  PortableServer::POA_var poa = pc->get_POA ();
  PortableServer::ObjectId_var oid = pc->get_object_id ();
  poa->deactivate_object (oid.in());
}


// Implementation for interface NamingContextExt

char*
KontoNamingContextExt_impl::to_string( const CosNaming::Name& n )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::InvalidName)

{
  char* retval;

  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

  return retval; 
}


CosNaming::Name*
KontoNamingContextExt_impl::to_name( const char* sn )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::InvalidName)

{
  CosNaming::Name* retval;

  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

  return retval; 
}


char*
KontoNamingContextExt_impl::to_url( const char* addr, const char* sn )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContextExt::InvalidAddress,
    ::CosNaming::NamingContext::InvalidName)

{
  char* retval;

  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

  return retval; 
}


CORBA::Object_ptr
KontoNamingContextExt_impl::resolve_str( const char* n )
  throw(
    ::CORBA::SystemException,
    ::CosNaming::NamingContext::NotFound,
    ::CosNaming::NamingContext::CannotProceed,
    ::CosNaming::NamingContext::InvalidName,
    ::CosNaming::NamingContext::AlreadyBound)

{
  CORBA::Object_ptr retval;

  // add your implementation here
    // REMOVE  
    mico_throw(::CORBA::NO_IMPLEMENT());
    // REMOVE 

  return retval; 
}
