
#ifndef __COSNAMING_IMPL_H__
#define __COSNAMING_IMPL_H__

#include"CosNaming.h"
#include<rpglib.h>

// Implementation for interface NamingContext
class KontoNamingContext_impl : virtual public POA_CosNaming::NamingContext
{
 protected:
  PortableServer::POA_var kontopoa;
  PgConnection *pdb;
 public:
    KontoNamingContext_impl(PortableServer::POA_ptr kpoa,PgConnection *pgdb)
    {
        kontopoa=kpoa;
        pdb=pgdb;
    }

    void bind( const CosNaming::Name& n, CORBA::Object_ptr obj )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName,
        ::CosNaming::NamingContext::AlreadyBound)
    ;

    void rebind( const CosNaming::Name& n, CORBA::Object_ptr obj )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName)
    ;

    void bind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName,
        ::CosNaming::NamingContext::AlreadyBound)
    ;

    void rebind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName)
    ;

    CORBA::Object_ptr resolve( const CosNaming::Name& n )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName)
    ;

    void unbind( const CosNaming::Name& n )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName)
    ;

    CosNaming::NamingContext_ptr new_context()
      throw(
        ::CORBA::SystemException)
    ;

    CosNaming::NamingContext_ptr bind_new_context( const CosNaming::Name& n )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::AlreadyBound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName)
    ;

    void destroy()
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotEmpty)
    ;

    void list( CORBA::ULong how_many, CosNaming::BindingList*& bl, CosNaming::BindingIterator_ptr& bi )
      throw(
        ::CORBA::SystemException)
    ;
};


// Implementation for interface BindingIterator
class KontoBindingIterator_impl : virtual public POA_CosNaming::BindingIterator
{
    PGresult *res;
    int akt;
 public:
    KontoBindingIterator_impl(PGresult *r,int a)
        {
            res=r;akt=a;
        }
    CORBA::Boolean next_one( CosNaming::Binding*& b )
      throw(
        ::CORBA::SystemException)
    ;

    CORBA::Boolean next_n( CORBA::ULong how_many, CosNaming::BindingList*& bl )
      throw(
        ::CORBA::SystemException)
    ;

    void destroy()
      throw(
        ::CORBA::SystemException)
    ;
};


// Implementation for interface NamingContextExt
class KontoNamingContextExt_impl : 
  virtual public KontoNamingContext_impl,
  virtual public POA_CosNaming::NamingContextExt
{
  public:
  KontoNamingContextExt_impl(PortableServer::POA_ptr kpoa,PgConnection *pgdb)
        :KontoNamingContext_impl(kpoa,pgdb),POA_CosNaming::NamingContextExt()
        {
        }

    char* to_string( const CosNaming::Name& n )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::InvalidName)
    ;

    CosNaming::Name* to_name( const char* sn )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::InvalidName)
    ;

    char* to_url( const char* addr, const char* sn )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContextExt::InvalidAddress,
        ::CosNaming::NamingContext::InvalidName)
    ;

    CORBA::Object_ptr resolve_str( const char* n )
      throw(
        ::CORBA::SystemException,
        ::CosNaming::NamingContext::NotFound,
        ::CosNaming::NamingContext::CannotProceed,
        ::CosNaming::NamingContext::InvalidName,
        ::CosNaming::NamingContext::AlreadyBound)
    ;
};


#endif
