#ifndef TRANSACTIONVAL_IMPL_H
#define TRANSACTIONVAL_IMPL_H
#include"buchtrans.h"

class transaction_impl: virtual public OBV_buch::transaction,
			virtual  public CORBA::DefaultValueRefCountBase
{
public:
    transaction_impl():OBV_buch::transaction() {};
    transaction_impl(buch::Tid _tid, const char* _text, const buch::Halbsatz_seq& _hs):transaction(_tid,_text,_hs)
	{
	}
};

class transaction_factory : virtual public buch::transaction_init
{
public:
    CORBA::ValueBase *create_for_unmarshal();
    buch::transaction *create (buch::Tid tid, const char* text,
			       const buch::Halbsatz_seq& hs);


};

class faelligkeit_impl : virtual public OBV_buch::faelligkeit,
			 virtual  public CORBA::DefaultValueRefCountBase
{
public:
    faelligkeit_impl():OBV_buch::faelligkeit() {}
    faelligkeit_impl(buch::Tid _tid, const char* _text, const buch::Halbsatz_seq& _hs,const buch::date& _faellig):OBV_buch::transaction(_tid,_text,_hs),OBV_buch::faelligkeit(_faellig) {}
};

class faelligkeit_factory : virtual public buch::faelligkeit_init
{
public:
    CORBA::ValueBase *create_for_unmarshal();
    buch::faelligkeit *create(buch::Tid tid, const char* text,
			      const buch::Halbsatz_seq& hs,const buch::date& _faellig);
};
#endif





